//---------------------------------------------------------------------------
#include <vcl.h>
#include "Conduite.h"
#pragma hdrstop
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "OpenGLPanel"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
#include <math.h>
#include <stdlib.h>
#include <stdio.h>
 float a=0;
 //--------------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
        dT=0.1;
        x=-30.0f;
        y=-20.0f;
        z=40.0f;
        r=0.0f;
        t=80.0f;
        w1=0;
        w2=0;
        e=0;
        h=0  ;
        angledrapeau=8;

        TimerAffichage->Interval = 10;
        TimerdT->Interval = dT*1000;

}
//----------------------------------------------------------------------------
void __fastcall TForm1::OpenGLPanel1Init(TObject *Sender)
{
        glViewport(0,0,OpenGLPanel1->Width,OpenGLPanel1->Height);
	glMatrixMode(GL_PROJECTION);
        if ( OpenGLPanel1->Height==0)
     	        gluPerspective(70, (GLdouble)OpenGLPanel1->Width, 1.0, 2000.0);
        else
                gluPerspective(70, (GLdouble)OpenGLPanel1->Width/
                           (GLdouble)OpenGLPanel1->Height,1.0, 2000.0);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

        glEnable(GL_DEPTH_TEST);

        glClearColor(0.8,0.8,1.0,0.1); //ciel

        GLfloat LightAmbient[]={ 1.0,1.0,1.0,1.0};
        GLfloat LightDiffuse[]={ 1.0f, 1.0f, 1.0f, 1.0f };
        GLfloat light_specular[]={1.0,1.0,1.0,1.0};
        GLfloat LightPosition[]= {10.0f,10.0f,10.0f, 1.0f };
        glEnable(GL_LIGHTING);
        glLightfv(GL_LIGHT0, GL_AMBIENT, LightAmbient);
        glLightfv(GL_LIGHT0, GL_DIFFUSE, LightDiffuse);
        glLightfv(GL_LIGHT0,GL_SPECULAR,light_specular);
        glLightfv(GL_LIGHT0, GL_POSITION,LightPosition);
	glEnable(GL_LIGHT0);


    /*
         glEnable(GL_FOG) ;
GLfloat fogcolor[4] = {0.8, 0.8, 0.8, 1} ;
GLint fogmode = GL_EXP ;
glFogi (GL_FOG_MODE, fogmode) ;
glFogfv(GL_FOG_COLOR, fogcolor) ;
glFogf(GL_FOG_DENSITY, 0.07) ;
//glFogf(GL_FOG_START, 30.0) ;
//glFogf(GL_FOG_END, 60.0);
                              */
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OpenGLPanel1Paint(TObject *Sender)
{       glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

      	glLoadIdentity();

        char temp[255];
       sprintf(temp,"dT = %f et u1 = %f  et u2=%f et deltag=%f et V=%f",
                  dT ,Bateau1.u1,Bateau1.u2,Bateau1.etat.deltag,Bateau1.V);


       Memo1->Text=temp;

        Bateau1.V=TrackBar5->Position;

        h= TrackBar4->Position ;
        z= TrackBar6->Position ;
        x+=h*cos(e*DegToRad)/100;
        y+=-h*sin(e*DegToRad)/100;
        e=TrackBar3->Position ;
        gluLookAt(x,y,z,x+100*cos(e*DegToRad),y-100*sin(e*DegToRad),0,0,0,1);



        glPushMatrix(); //croix

                 glLineWidth(4);
        glBegin(GL_LINES);
                glColor3f(1,0,0);
                glVertex3f(Bateau1.xd+5,Bateau1.yd+5,0.1);     glVertex3f(Bateau1.xd-5,Bateau1.yd-5,0.1);
        glEnd();
        glBegin(GL_LINES);
                glColor3f(1,0,0);
                glVertex3f(Bateau1.xd+5,Bateau1.yd-5,0.1);     glVertex3f(Bateau1.xd-5,Bateau1.yd+5,0.1);
        glEnd();
        glPopMatrix();

        GLfloat amb[4] = { 1, 1, 1, 0.5 };
        GLfloat dif[4] = { 1.0, 1.0, 1.0, 0.5 };
        GLfloat spec[4] = { 2, 2, 2, 1.0 };

        glEnable(GL_COLOR_MATERIAL);      // reflet
        glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, dif);
        glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, amb);
        glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, spec);
        glMaterialf(GL_FRONT_AND_BACK, GL_SHININESS, 25.0);



        glColor3f(0.6,0,0);   // Sphere rouge
        GLUquadricObj* q=gluNewQuadric();
        gluQuadricDrawStyle(q,GLU_FILL);
        gluSphere(q,1.0,10,10);
        gluDeleteQuadric(q);

        angledrapeau= -angledrapeau; //dessiner le drapeau
        glPushMatrix();
        glRotatef(angledrapeau,0,0,1);
        glBegin(GL_POLYGON);
        glColor3f(0,0.7,0);
        glVertex3f(0,0,15);   glVertex3f(0,-4,14); glVertex3f(0,0,13);
        glEnd();
        glPopMatrix();





        glLineWidth(4);    //poteau
        glBegin(GL_LINES);
        glColor3f(0,0,0);
        glVertex3f(0,0,0);  glVertex3f(0,0,15);
        glEnd();

        glBegin(GL_POLYGON); //mer
                glColor3f(0,0.7,1);
                glVertex3f(-10000,-10000,0);      glVertex3f(10000,-10000,0);
                glVertex3f(10000,10000,0);        glVertex3f(-10000,10000,0);
        glEnd();

        glEnable( GL_NORMALIZE );
        Bateau1.Draw();



        glPopMatrix();

}
//---------------------------------------------------------------------------
void __fastcall TForm1::ButtonStartClick(TObject *Sender)
        {Bateau1=Bateau();}
//---------------------------------------------------------------------------
void __fastcall TForm1::TimerAffichageClock(TObject *Sender)
        {OpenGLPanel1->Repaint();
         char temp[255];
        sprintf(temp,"%f",Bateau1.etat.v);
        Form1->Edit2->Text=temp;

        sprintf(temp,"%f",Bateau1.etat.x);
        Form1->Edit3->Text=temp;

         sprintf(temp,"%f",Bateau1.etat.y);
         Form1->Edit4->Text=temp;

         sprintf(temp,"%f",Bateau1.etat.theta*RadToDeg);
         Form1->Edit5->Text=temp;

          sprintf(temp,"%f",Bateau1.etat.omega);
         Form1->Edit6->Text=temp;

          sprintf(temp,"%f",Bateau1.fv);
         Form1->Edit7->Text=temp;

           sprintf(temp,"%f",Bateau1.fg);
         Form1->Edit8->Text=temp;

             sprintf(temp,"%f",Bateau1.qq);
         Form1->Edit9->Text=temp;

             sprintf(temp,"%f",(Bateau1.cap)*RadToDeg);
         Form1->Edit10->Text=temp;

             sprintf(temp,"%f",w1*RadToDeg);
         Form1->Edit11->Text=temp;


             sprintf(temp,"%f",w2*RadToDeg);
         Form1->Edit12->Text=temp;


          sprintf(temp,"%f",Bateau1.etat.deltav*RadToDeg);
         Form1->Edit13->Text=temp;
            Bateau1.xd=TrackBar1->Position;
        Bateau1.yd=TrackBar2->Position;


         }
//---------------------------------------------------------------------------
void __fastcall TForm1::TimerdTClock(TObject *Sender)
{

       w2=Bateau1.Automate(dT);
       w1=Bateau1.Ouverture();
       Bateau1.Incremente(dT,w1,w2);

}
//---------------------------------------------------------------------------
void __fastcall TForm1::ButtonStartKeyPress(TObject *Sender, char &Key)
{switch (Key)
 { 
   case 'z': z=z+1;    break;
   case 'Z': z=z-1;    break;
 }
}
//---------------------------------------------------------------------------




